#include "cpu.h"
#include <avr/io.h>

#ifndef MY_TYPES_H
	#include "my_types.h"
#endif

/************************************************************************/
/*                                                                      */
/*                      RC5 Remote Receiver                             */
/*                                                                      */
/*              Author: Peter Dannegger                                 */
/*                      danni@specs.de                                  */
/*                                                                      */
/************************************************************************/
#include <avr/interrupt.h>
//#include <avr/signal.h>
#include <stdlib.h>

#include "rc5.h"
//#include "irmp.h"

#define	xRC5_IN		PIND
#define	xRC5			PD6			// IR input low active

UBYTE	rc5_bit;				// bit value
UBYTE	rc5_time;				// count bit time
UWORD	rc5_tmp;				// shift bits in
UWORD	rc5_data;				// store result


//SIGNAL (SIG_OVERFLOW0)
void rc5_ISR(void)                                     // call irmp ISR
{	UWORD tmp = rc5_tmp;
//	TCNT0 = -2;	// 2 * 256 = 512 cycle	// preload for 250s RC5 // in timer0 ISR

  	if( ++rc5_time > PULSE_MAX )
	{	// count pulse time
    	if( !(tmp & 0x4000) && tmp & 0x2000 )	// only if 14 bits received
		rc5_data = tmp;
    	tmp = 0;
  	}

  	if( (rc5_bit ^ xRC5_IN) & 1<<xRC5 )
	{	// change detect
    	rc5_bit = ~rc5_bit;						// 0x00 -> 0xFF -> 0x00

    	if( rc5_time < PULSE_MIN )				// to short
      		tmp = 0;

    	if( !tmp || rc5_time > PULSE_1_2 )
		{	// start or long pulse time
      		if( !(tmp & 0x4000) )				// not to many bits
        		tmp <<= 1;						// shift
      		if( !(rc5_bit & 1<<xRC5) )			// inverted bit
        		tmp |= 1;						// insert new bit
      		rc5_time = 0;						// count next pulse time
    	}
  	}
  	rc5_tmp = tmp;
}

