#include <avr/interrupt.h>
#include <inttypes.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/sleep.h>
#include <string.h>
#include <util/delay.h>
#include <util/delay.h>

#ifndef MY_TYPES_H_
	#include "my_types.h"
#endif

#include "bits.h"
#include "calen.h"
#include "__dcf77.h"
#include "i2cmaster.h"
#include "i2c_rtc.h"
#include "i2c_key.h"
#include "irmp.h"
#include "irmpconfig.h"
#include "IR_drv.h"
#include "lcd6.h"
#include "menu.h"
#include "programs.h"
#include "rc5.h"
#include "s_tools.h"
#include "uart.h"

static const char *Proto[]={ \
"SIRCS","NEC","SAMSUNG","MATSUSH","KASEIKYO","RECS80","RC5(x)","DENON","RC6","SAMSG32",\
"APPLE","RECS80x","NUBERT","BANG_OLUF","GRUNDIG","NOKIA","SIEMENS","FDC","RCCAR","JVC",\
"RC6A","NIKON", "RUWIDO","IR60","KATHREIN","NETBOX","NEC16","NEC42","LEGO","THOMSON", \
"MERLIN"};

IRMP_DATA irmp_data;
UWORD 	p_old=0, i_=0, L_Com=0, Old_L_Com=0;
UBYTE show_irmp=0;


char s[20], gg;
volatile UWORD count__=0;
volatile uint8_t count2__=(uint8_t)(F_INTERRUPTS/100L);
volatile uint8_t _1_4_count=3;
volatile UBYTE _ms10=0;
volatile uint8_t _ms10_i2c_read_once_wunsch=0;
volatile uint8_t _ms10_i2c_read_once_true=0;
//TEST_PORT ^= (1<<_test);
volatile BOOL 	bedient=FALSE;
uint8_t 	res_key;
uint8_t 	_dcfBIT;
uint8_t 	ms10count=0;
volatile ULONG	fast_it=0;
BOOL alarm_set=FALSE;
UWORD merke_rc5;

extern volatile UWORD 	_beep500ms;
extern volatile uint8_t ms_powerLED_flag;
extern volatile uint8_t ms_speedLED_flag;
extern volatile uint8_t ms_irLED_flag;
extern volatile uint8_t ms_dcfLED_flag;
extern volatile uint8_t ms_ausloes_flag;

volatile uint8_t i2c_test_flags;
volatile uint8_t _timerlaeuft=FALSE;

#ifdef TEST_
volatile uint8_t test=1;
#endif
uint8_t	_i2c_dcf_in;
uint8_t	_i2c_10ms_in;

extern uint8_t kon;
extern uint8_t hell;
extern uint8_t _beep_;

extern struct _NEWTIME newtime;

uint8_t set_flags=0;

#ifndef F_CPU
#error F_CPU unkown
#endif

//#define IR_FREQUENZ 36000L

//PROGMEM char pic1[] = LOGO;


#define WAIT_A_BISSL 250


uint8_t timeflags;
uint8_t dcf77_period=0, alte_dcf77_period=0;
uint8_t dcf77_pulse;
#define ONE_TICK	0
#define ONE_SECOND	1
#define ONE_MINUTE	2


uint8_t dcf77_time, old_dcf77;
uint8_t woher=0, _merke_beep20=0;

void __tab(void);
void scr_up(void);
void scr_down(void);

const char* menus[]= { \
"",
"1.Auslsung", 
"2.Ausschalten", 
"3.Bildserie", 
"4.Bel.serie", 
"5.Zufallsbilder", 
"6.Licht", 
"7.Cam Setting",
"8.PowerStatus", 
"9.Uhr",
"10.Status", 
"11.TimerSetting",
"12.Uhr Status", 
"13.Char Set", 
"14.Key Test", 
"15.Uhr stellen", 
"16.IRMP", 
#ifdef BEEPER
"17.Beep ON/OFF", 
#endif
"",
"1.blink   ", // 17
"2.IR RC5  ", // 18
"3.DCF77   ", // 19
""
}; 

const char* strings[]= { \
"", 							// 0
" SVA? . ", 				// 1
  "     bulb          ", 		// 2
  "     darkframe     ", 		// 3
//"Anfangszeit ? 1/100", 	// 27
//"01234567890123456789"	// 27
//"Anfangszeit ?   ...", 	// 27
"nchstes: ...", 			// 4 
"  wakeup", 				// 5
"   klick", 				// 6
"SVA      Rausch",     	// 7
"AutopowerOff ", 			// 8
"15 min", 					// 9
"30 min", 					// 10
"   p   ", 					// 11
" P   c", 					// 12
"rtc", 						// 13
"dcf", 						// 14
" AN", 						// 15
"AUS", 						// 16
"AN1", 						// 17
"AN2", 						// 18
"min", 						// 19
"LCD=", 						// 20
">999", 						// 21
"ms", 						// 22
"Vcc   V   mA", 			// 23
"Bat   V   mA", 			// 24
"Ch.       Ch.", 			// 25
"Zwischenzeit ?  ..", 	// 26
"Anfangszeit ?   ...", 	// 27
"old=...s akt=...s", 	// 28
"RC5= ../..  ../..", 	// 29
"Vorlf?... Anzahl?.. ", // 30
"Uhr", 						// 31
"              ", 		// 32
"" 
}; 

uint8_t 	check_ms=1;
BOOL 	not_checked=FALSE;
volatile uint8_t line_=1, beginn_=0;

volatile uint8_t 	__p, _tab=1;
UWORD 	count=0, p_tab=0;
volatile char _uhr_string[12]="leer";
volatile ULONG time1_;
volatile ULONG time2_;
volatile uint8_t last_kohe=' ';
BOOL 		KoHe_flag=FALSE;

ULONG 	_hk_sec=0;

// p11 datumsumschaltung uhr status
BOOL d_flag=FALSE;
BOOL next_second=FALSE;

// cam parameter
BOOL 	_wakeup=FALSE;
BOOL 	_wake=TRUE;

// von _darkframe genutzt
volatile ULONG	w4=0;

// Cam Parameter
uint8_t		_autopower=2;
BOOL 		__sva=FALSE;
uint8_t 	_rausch=_AN1;
// von ausloesung genutzt
//_eeprom.cam_delay=_CAM_DELAYx10MS;
//UWORD 	cam_delay=_CAM_DELAYx10MS; bald gebraucht wenn aus den EEPROM geholt, noch per preprozessor als define

// TimerParameter
volatile BOOL war_alarm=FALSE;

char rtc_string[41];

ULONG hilf_=0;

extern char 	p3_cnt[];

// von ausloesung genutzt
volatile ULONG	w0=0;
volatile BOOL 	_ausloes=FALSE;
volatile ULONG	last_cam_action=0;

//BOOL 	p8_stat=FALSE;
BOOL 	p8_stat=TRUE;

BOOL 	p8_stat_merke=FALSE ;

// von p9 (3.Uhr) genutzt
BOOL  	res_p9=FALSE;

// von p10 (10.TimerSetting) genutzt
volatile uint8_t	h_beginn_p10=0;
volatile uint8_t	h_line_p10=1;
UWORD cpu_idle;
volatile uint8_t _p_run=0;

volatile BOOL	_darkframe=FALSE;
volatile BOOL	_darkframe_ende=FALSE;

// die blinker var
ULONG 	w1=0;
BOOL 	_bli=FALSE;
BOOL 	_bli_set=TRUE;
uint8_t	_bli_ersatz;
uint8_t 	c10=0;
uint8_t 	ph=0;

BOOL 	merke_sva;

extern uint8_t 	__bi1;
extern uint8_t 	__bi2;
extern uint8_t 	__vo1;
extern uint8_t 	__vo2;
extern uint8_t 	__zw1;
extern UWORD 	__zw2;



//---------------------------------------------------------------------------------------------------------------------------------------------------
// timer 0 compare handler, called every 1/10000 sec
//---------------------------------------------------------------------------------------------------------------------------------------------------
//
SIGNAL (SIG_OVERFLOW0)
{	extern volatile UWORD count__;
	cli();
	count__++;
	TCNT0 = -2;					// 2 * 256 = 512 cycle			// preload for 250s RC5

  	(void) irmp_ISR();                                     // call irmp ISR
	(void) rc5_ISR();
	sei();
}

SIGNAL (SIG_OUTPUT_COMPARE2A)
{	static uint8_t ct0, ct1, rpt;
	uint8_t i=0;
//-------------
//  static uint8_t dcf77_time, old_dcf77;
//-------------
	cli();

	_ms10++;
	fast_it++;

	if(OCR2A==77)
		OCR2A=76;
	else
		OCR2A=77;

	if(ms_powerLED_flag)
	{	ms_powerLED_flag--;
		if(!ms_powerLED_flag)
			gruenLED(TOGGLE);	
	}

	if(ms_speedLED_flag)
	{	ms_speedLED_flag--;
		if(!ms_speedLED_flag)
			speedLED(TOGGLE);
	}

	if(ms_irLED_flag)
	{	ms_irLED_flag--;
		if(!ms_irLED_flag)
			irPOWER(TOGGLE);
	}

	if(ms_ausloes_flag)
	{	ms_ausloes_flag--;
		if(!ms_ausloes_flag)
			ausloes(TOGGLE);	
	}
/*
	if(ms_dcfLED_flag)
	{	ms_dcfLED_flag--;
		if(!ms_dcfLED_flag)
			gelbLED(1);
	}
*/
#ifdef BEEPER
	if(_beep500ms)
	{	_beep500ms--;
		if(!_beep500ms)
			beep(FALSE);
	}
#endif
	if(wait_hell_flag)
		wait_hell_flag--;

	if(_i2c_key)
	{	if(!_i2c_busy)
		{	if(_i2c_key=='A')
			{	if(!i2c_start(PCF8574A_0+I2C_READ))	//;	// set device address and write mode
					i = key_state ^ ( ( ~(BYTE)i2c_readNak() ) );		
				i2c_stop();
			}
			else
			{	if(!i2c_start(PCF8574_0+I2C_READ))	//;	// set device address and write mode
					i = key_state ^ ( ( ~(BYTE)i2c_readNak() ) );		
				i2c_stop();
			}
		}

#ifdef DCF77_INVERTED
		;
#else
		DCF77_PIN = i & (1<<DCF77_);
#endif
		_i2c_10ms_in = i & (1<<UNIVERSELL_I2C_BIT);

		i &= ALL_KEYS;
		ct0 = ~( ct0 & i );                             // reset or count ct0
		ct1 = ct0 ^ (ct1 & i);                          // reset or count ct1
		i &= ct0 & ct1;                                 // count until roll over ?
		key_state ^= i;                                 // then toggle debounced state
		key_press |= key_state & i;                     // 0->1: key press detect
 
		if( (key_state & REPEAT_MASK) == 0 )            // check repeat function
	  		rpt = REPEAT_START;                          // start delay
		if( --rpt == 0 )
		{	rpt = REPEAT_NEXT;                            // repeat delay
	  		key_rpt |= key_state & REPEAT_MASK;
		}

	}
//	TEST_PORT |= (1<<_test);
//--------------------------------------------------------------------
	// DCF77 receive
	if( dcf77_time != 0xFF )					// stop on 0xFF
		dcf77_time++; 								// count ticks
//TEST_PORT
#ifdef DCF77_INVERTED
	//#warning INVERTIERT ON
	if( ~(DCF77_PIN_in ^ old_dcf77) & 1<<DCF77_bit_in )
	//if( ~(DCF77_PORT_in ^ old_dcf77) & 1<<DCF77_bit_in )
#else
	if( (DCF77_PIN ^ old_dcf77) & 1<<DCF77_ )
#endif
	{ // pin changed ?
		old_dcf77 ^= 0xFF; 					// change old flag

#ifdef DCF77_INVERTED
		//#warning INVERTIERT ON
		if( old_dcf77 & 1<<DCF77_in )
#else
		if( old_dcf77 & 1<<DCF77_ )
#endif
		{	dcf77_period = dcf77_time; 	// store ticks of period
			dcf77_time = 0; 					// count next period
		}
		else
			dcf77_pulse = dcf77_time;		// store ticks of pulse
	}
	if( _ms10 & 99 )	// 99 //64 ticks = one second
	{
		timeflags = 1<<ONE_TICK;			// one tick over
		_ms10=0;
	}
	//return;
//--------------------------------------------------------------------
//	TEST_PORT &= ~(1<<_test);

	sei();
}

void menu(void)
{	UBYTE menu_tmp;
	lcd_set();
	for(menu_tmp=0; menu_tmp<LCD_LINES; menu_tmp++)
	{	lcd_gotoxy(1,menu_tmp); lcd_puts(menus[(menu_tmp+1+beginn_)]); //lcd_puts(menus[(menu_tmp+1+beginn_)]); // 
	}
	lcd_gotoxy(0, (line_-1)); 
	if( !(line_-1) && !beginn_ )  						// 0 + 0 
		lcd_putc(126);													// >
	else
	{	if( (line_-1)>0 && (line_-1)<LCD_LINES )  				// 1 - 2
			lcd_putc(126);													// >
		else
		{	//eeprom_read_block(&s,&ee_mem[(5+beginn_)<<4],16);
			if( (line_-1)==LCD_LINES && strlen( menus[(5+beginn_)]) ) 	// 3 + 1 strlen( s) menus[(5+beginn_)]
				lcd_putc(7);													// down
			else
			{	if( !(line_-1) && beginn_ ) 				//	0 + 1
					lcd_putc(6);													// up
				else
					lcd_putc(126);													// >
			}
		}
	}
}

void fb(void)
{  
// 	static uint16_t toggle_bit;

	if( i_ )
	{	//_toggelbit = ( i_ >> 11 & 1);
		L_Com	=	(i_ >> 6 & 0x1F)*100;
      L_Com	+=	(i_ & 0x3F) | (~i_ >> 7 & 0x40);
		//'If Address < 255 Then
   	if(( i_ >> 11 & 1)==1)
			L_Com|=(1<<15);
		else
      	L_Com&=~(1<<15);
/*
	if( irmp_get_data(&irmp_data) && irmp_data.protocol == IRMP_RC5_PROTOCOL )
  	{  
		L_Com = (((irmp_data.address*100) + irmp_data.command) & 0x7fff); // L_Com aus Adresse und Kommando zusammenbauen

		if( !(irmp_data.flags & IRMP_FLAG_REPETITION) )
    	{
			toggle_bit ^= (1<<15);    // Togglen
      	L_Com |= toggle_bit;
    	}
*/	 
		if(((L_Com&0x7fff)/100) == 7 || ((L_Com&0x7fff)/100) == 30)
		{	if( count < 998 )
			{	if(Old_L_Com == L_Com) 	
					count++;
				else							
					count=0; 
				
				itoa(count,  s, 10); 
			}
			else
			{	strcpy( s, ">999");	}

			bedient=TRUE;
			switch( L_Com&0x7fff )
			{	
				case PINN_1:	// p1 pinnacle taste "1"
				case PINN_REC:	// rec pinnacle taste ""
				case 3001:
				case 3055:	// hauppauge taste "o" ' RECORD 
					if((Old_L_Com != L_Com) && !(_p_run==2))
					{	//if(_p_run!=_ZUFALLSBILDER)
							_p_run=0; 
							ausloes(_CAM_CLEAR);
							ausloes(_CAM_DELAYx10MS);
					}
					break;
	/*
					case PINN_2:	// p2 pinnacle taste "2"
					case 3002:
					case PINN_POWER_OFF:	// off pinnacle taste "off"
					case 3061:	// off hauppauge taste "off"
						if(__p==_STATUS || __p==_IRMP)
						{	if(count> 10)	{	p_old=80; __p=_HAUPTMENU; count=0;	}	}
						else
						{	
							alarm1_clr_rtc();
							//set_sleep_mode(SLEEP_MODE_PWR_SAVE);
							//alarm1_set_rel_rtc(40);
							//alarm_zeit=fast_it+500;
							alarm_set=TRUE;
							shutdown(SLEEP_MODE_PWR_DOWN);

							__p=99;
						}
						break;
	*/
				case PINN_3:	// p3 pinnacle taste "3"
				case 3003:
					if(__p==_STATUS || __p==_IRMP)	
					{	if(count> 10)	{	p_old=83; __p=_BILDSERIE; count=0;	}	}
					else		
						m1();
					break;

				case PINN_4:	// p4 pinnacle taste "4"
				//case 3003:
					if(__p==_STATUS || __p==_IRMP)	
					{	if(count> 10)	{	p_old=84; __p=_BEL_SERIE; count=0;	}	}
					else		
						m2();
					break;

				case PINN_5:	// p5 pinnacle taste "5"
				//case 3003:
					if(__p==_STATUS || __p==_IRMP)	
					{	if(count> 10)	{	p_old=85; __p=_ZUFALLSBILDER; count=0;	}	}
					else		
						m3();
					break;

				case PINN_GROSSER_KULLER:	// light 
				case PINN_6:	// p6 pinnacle taste "6"
				case 3006:	// light hauppauge taste "6"
				case 3015:	// light hauppauge taste "mute" MUTE
					if(__p==_STATUS || __p==_IRMP)
					{	if(count> 10)	{	p_old=86; __p=_LICHT; count=0;	}	}
					else
						if(Old_L_Com != L_Com)
							speedLED(TOGGLE);
					break;

				case PINN_7:	// p7 pinnacle taste "7"
				case 3007:
					if(__p==_STATUS || __p==_IRMP)
					{	if(count> 10)	{	p_old=87; __p=_CAM_SETTINGS; count=0;	}	}
					else
						m7();
					break;

				case PINN_8:	// p8 pinnacle taste "8"
				case 3008:	
					if(__p!=_STATUS)
					{	__p=_STATUS; _p_run=0; count=0; _Status(); }
					break;

				case PINN_9:	// p9 pinnacle taste "9"
				case 3009:
					if(__p==_STATUS || __p==_IRMP)
					{	if(count> 10)	{	p_old=89; __p=_UHR; count=0;	}	}
					else
						__p=_UHR;
					
					if(__p==_UHR)
					{	_p_run=0; count=0;	_Uhr();	}
					break;

				case PINN_RECHTECK:	// bli1 pinnacle "" links neben "0"
				case 3010:	// bli1 hauppauge "*" links neben "0"
					if(Old_L_Com != L_Com)
						if(!_bli)
							bli(_ONCE);
					break;

				case PINN_0:	// bli10 pinnacle taste "0"
				case 3000:	// bli10 hauppauge taste "0"
					if(__p==_STATUS || __p==_IRMP)
					{	if(count> 10)	{	p_old=90; __p=_TIMERSETTING; count=0;	}	}
					else
						__p=_TIMERSETTING;
					
					if(__p==_TIMERSETTING)
					{	_p_run=0; count=0;	_TimerSetting();	}
					break;

				case PINN_T:	// tab springt pinnacle taste "T"
				case 3014:	// tab springt hauppauge taste "#"
					if(Old_L_Com != L_Com)
						res_key=( 1<<KEY3 );
					break;

				case PINN_FOR:	// plus pinnacle taste ">>"
				case 3052:	// plus hauppauge taste ">>"
					if(__p==_HAUPTMENU || __p==_TIMERSETTING)
						res_key=( 1<<KEY5 ); //scr_down();
					else
							res_key=( 1<<KEY2 ); //plus();*/
					break;

				case PINN_REW:	// minus pinnacle taste "<<"
				case 3050:	// minus hauppauge taste "<<"
					if(__p==_HAUPTMENU || __p==_TIMERSETTING)
						res_key=( 1<<KEY2 ); //scr_up();
					else
						res_key=( 1<<KEY5 ); //minus();*/
					break;

				case PINN_PP:	// programm ausfhren pinnacle taste "||>"
				case 3053:	// programm ausfhren hauppauge taste ">"
					if(Old_L_Com != L_Com)
						res_key=(1<<KEY6);
					break;

				case PINN_QUADRAT:	// light pinnacle taste "stop"
				case 3054:	// light hauppauge taste "stop"
					if(__p==_STATUS || __p==_IRMP)
					{	if(count> 10)	{	p_old=80; __p=_HAUPTMENU; count=0;	}	}
					else
						__p=_HAUPTMENU;
					
					if(__p==_HAUPTMENU)
					{	_p_run=_HAUPTMENU; count=0; menu();	}
					break;

				case PINN_VOL_UP:	// kon up pinnacle taste "VOL up"
				case 3016:	// kon up hauppauge taste "VOL up"
					kon_plus();
					break;

				case PINN_VOL_DOWN:	// kon down pinnacle taste "VOL down"	
				case 3017:	// kon down hauppauge taste "VOL down"
	        		kon_minus();
					break;

				case PINN_CH_UP:	// hell up pinnacle taste "CH up"
				case 3032:	// hell up hauppauge taste "CH up"
					hg_led_plus();
					break;

				case PINN_CH_DOWN:	// hell down pinnacle taste "CH down"
				case 3033:	// hell down hauppauge taste "CH down"
					hg_led_minus();
					break;
				case PINN_HELP:	// ? pinnacle taste BREAK
					if(Old_L_Com != L_Com)
						if(!_bli)
							bli(_TEN);
					break;

				case PINN_2:	// p2 pinnacle taste "2"
				case 3002:
				case PINN_POWER_OFF:	// off pinnacle taste "off"
				case 3061:	// off hauppauge taste "off"
					lcd_clrscr();
					lcd_gotoxy(0,6); lcd_puts("5s power OFF Alarm1");
					merke_rc5=0;
					_delay_ms(3000);
					alarm1_set_rel_sec_max65536(5L);
					woher=shutdown(SLEEP_MODE_PWR_DOWN);
					_merke_beep20=~_merke_beep20;
					merke_rc5=PINN_SPEAKER;
					break;
	/*
				case PINN_5:
					lcd_clrscr();
					lcd_gotoxy(0,6); lcd_puts("5min power OFF Alarm2");
					merke_rc5=0;
					_delay_ms(3000);
					alarm2_set_rel_min_max65536(5L);
					woher=shutdown(SLEEP_MODE_PWR_DOWN);
					_merke_beep20=~_merke_beep20;
					merke_rc5=PINN_SPEAKER;
					break;
	*/
				default:
					bedient=FALSE;
					break;
			} // switch( L_Com&0x7fff )
			//L_Com=0;
			//count = 0;
		} // if(Address == 7 || Address == 30)
	} // 	if( irmp_get_data(&irmp_data) && irmp_data.protocol == IRMP_RC5_PROTOCOL )

	if(__p==_STATUS) 
	{	lcd_gotoxy(11,1); 
		lcd_puts((L_Com&(1<<15)) ? "T" : " " );
        	
		lcd_gotoxy(14,0); lcd_puts( trimm_string(' ',  s, 4)); 
		lcd_gotoxy(4,2);  lcd_puts(trimm_all( (100*kon/_KON_PEEK), hg_led_get(), 3 ) ); 
		lcd_gotoxy(12,1); 
		lcd_puts(insert_char(trimm_string('0', itoa( (L_Com&0x7fff), s, 10),4), '/',2)); 
			
		if(Old_L_Com)
		{	lcd_gotoxy(4,1);  lcd_puts(Old_L_Com&(1<<15) ? "T" : " " );			
			lcd_gotoxy(5,1); 
			lcd_puts(insert_char(trimm_string('0', itoa( (Old_L_Com&0x7fff), s, 10),4), '/',2)); 
		} // if(Old_L_Com)
	} // if(__p==_STATUS) 
	if(__p==_IRMP) 
	{
	} // if(__p==_IRMP) 

	if(Old_L_Com==0 || (Old_L_Com!=0 && Old_L_Com!=L_Com))
		Old_L_Com = L_Com;
} // void fb(void)

void flags_abarbeiten(void)
{
	#ifdef BEEPER
		if(set_flags & (1 << _BEEPER))
		{
			if( _beep500ms<5 && (BEEPER_PORT & (1 << _BEEPER)) )
			{
				BEEPER_PORT	&= ~(1 << _BEEPER);
				_beep500ms=BEEPOFF;
			}
			if(_beep500ms<5 && !(BEEPER_PORT & (1 << _BEEPER)) )
			{
				BEEPER_PORT	|= (1 << _BEEPER);
				_beep500ms=BEEPON;
			}
		}
	#endif // #ifdef BEEPER

	return;
}

extern void irmp_uart_putc(char);
extern const char DISPLAY_INIT[];
volatile uint8_t save_rtc_status=0;

int main (void)
{
	UBYTE blinki, sek10, _hell_perc;//, altetaste=0;		//, sek;//, t0_lauft=0;//

	char s2[20];
//1	//char UI_str[11]={0};

	UBYTE old_sec=0, u_count, __i;
	UBYTE __hour=0;
	UBYTE __minute=0;
	UBYTE __day=0;
	UBYTE __month=0;
	UWORD Ub, Ib, ubat, new_stat_grenze, off;
	UWORD __year=0;

	ULONG prog_beginn;
	ULONG alarm_beginn;
	ULONG alarm_zeit;
	ULONG dcf_timeout/*, _ulongdate*/;

	ULONG mAh=0;
	ULONG w3=0;

#ifdef TEST_
	uint8_t z;
#endif
	UWORD /*old_rc5=0, */ub, _ibat;
//	char temp[20];

#if IRMP_LOGGING != 0       // 1: log IR signal (scan), 0: do not (default)
	char temp2[255], UI_str[22]={0};//, c1=0;
#endif
//1
	char UI_str[22]={0};//, c1=0;

	save_rtc_status=0;
neustart:

	blinki=0; sek10=0; _hell_perc=0; res_key=0; merke_rc5=0; ub=0; _ibat=0; UI_str[0]=0, show_irmp=0;


	old_sec=0;	u_count=0; __i=0;
	Ub=0; Ub=0; Ib=0; ubat=0; new_stat_grenze=0; cpu_idle=0; Ib=0; ubat=0; off=0; new_stat_grenze=0;

	prog_beginn=0; alarm_beginn=0; alarm_zeit=0; mAh=0; dcf_timeout=_DCFTIMEOUT;
	fast_it=0;
	bedient=FALSE;



#if IRMP_LOGGING != 0       // 1: log IR signal (scan), 0: do not (default)
	temp2[0]=0;
#endif

	set_sleep_mode(SLEEP_MODE_PWR_DOWN); // sieht man ! NEUSTART
	EICRA |=1<<ISC10;
	EICRA |=1<<ISC11;

	cli();
	PCMSK3&=~(1<<PCINT27);
	PCICR&=~(1<<PCIE3);

#ifdef TEST_
	z=0; 
#endif
	
	timer0_init();		// init timer0 fur IR 			-> s_tools_small2.c
	timer2_init();		// init timer0 fur ms10 & key -> i2c_key.c
	irmp_init();		// initialize IR 					-> irmp.c
	i2c_init();			// initialize I2C 				-> i2cmaster.c

	if(test_i2c_rtc())
		alarm1_clr_rtc();

	test_i2c_key();

	/* initialize display, cursor off */
	lcd_init(LCD_DISP_ON);  // LCD_DISP_ON_CURSOR_BLINK
	
	TEST_DDR |= (1<<_test);
	TEST_PORT &= ~(1<<_test);
	//TEST_PORT ^= (1<<_test);

	init_clock(0);	// __clock.c

	sei();

	all_led(RESET);
	all_led(25);
_delay_ms(250);
	all_led(25);
_delay_ms(250);
	all_led(25);
_delay_ms(250);

#if IRMP_LOGGING != 0       // 1: log IR signal (scan), 0: do not (default)
	uart_init(UART_BAUD_SELECT(9600,F_CPU));
#endif

#ifdef TEST_
lcd_clrscr();
_delay_ms(2500);
for (z=0;z<255;z++)
{
	lcd_gotoxy( ((z&1)*10),(z>>1)&7);
	lcd_putc(z);
	lcd_puts(" ");lcd_puts(trimm_string(' ',itoa(z, temp2, 10), 3) );
	lcd_puts(" ");lcd_puts(trimm_string('0',itoa(z, temp2, 16), 2) );
	if((z+1)%16==0)
		{_delay_ms(2500); lcd_clrscr(); ausloes(); }
}
_delay_ms(2500);
test=0;
lcd_clrscr();
ausloes();
#endif //test

#ifdef TEST2_
lcd_clrscr();
lcd_gotoxy(0,0);lcd_puts("  0123456789ABCDEF");
lcd_gotoxy(0,1);lcd_puts("0  ?????????????");
lcd_gotoxy(0,2);lcd_puts("1 ??????????????");
//lcd_gotoxy(0,3);lcd_puts("2  !"#$%&'()*+,-./");
lcd_gotoxy(0,4);lcd_puts("3 0123456789:;<=>?");
lcd_gotoxy(0,5);lcd_puts("4 @ABCDEFGHIJKLMNO");
lcd_gotoxy(0,6);lcd_puts("5 PQRSTUVWXYZ[\]^_");
lcd_gotoxy(0,7);lcd_puts("6 `abcdefghijklmno");

lcd_gotoxy(0,1);lcd_puts("7 pqrstuvwxyz{|}~");
lcd_gotoxy(0,2);lcd_puts("8 ");
lcd_gotoxy(0,3);lcd_puts("9 ׃");
lcd_gotoxy(0,4);lcd_puts("A Ѫ");
lcd_gotoxy(0,5);lcd_puts("B ¦+++");
lcd_gotoxy(0,6);lcd_puts("C +--+-+++---+");
lcd_gotoxy(0,7);lcd_puts("D i++_");

lcd_gotoxy(0,1);lcd_puts("E յݯ");
lcd_gotoxy(0,2);lcd_puts("F =");

//789ABCDF");
#endif //test

	lcd_clrscr();

goto weiter;

lcd_gotoxy(0,0);lcd_puts("12345678901234567890A");
lcd_gotoxy(0,1);lcd_puts("12345678901234567890A");
lcd_gotoxy(0,2);lcd_puts("12345678901234567890A");
lcd_gotoxy(0,3);lcd_puts("12345678901234567890A");
lcd_gotoxy(0,4);lcd_puts("12345678901234567890A");
lcd_gotoxy(0,5);lcd_puts("12345678901234567890A");
lcd_gotoxy(0,6);lcd_puts("12345678901234567890A");
lcd_gotoxy(0,7);lcd_puts("12345678901234567890A");

_delay_ms(2500);

_delay_ms(2500);
_delay_ms(2500);
_delay_ms(2500);

weiter:
	lcd_clrscr();
	lcd_gotoxy(1,7); lcd_puts(time._builddate_); lcd_puts(" "); lcd_puts(time._buildtime_);
//stop(1);

	//if(_merke_beep20)
	//	beep(20);
	//set_flags |= (1 << _BEEPER);
#ifdef BEEPER
	beep(20);
	merke_rc5=PINN_SPEAKER;
#endif

	DCF_LED_DDR |= (1<<_dcfLED);			// gelbLED Anode output		
	DCF_LED_PORT|= (1<<_dcfLED);			// gelbLED Anode high		
	DCF77_DDR_in &= ~(1<<DCF77_bit_in);				// gelbLED Kathode input		
	DCF77_PORT_in |= (1<<DCF77_bit_in);				// gelbLED Kathode pullup enable		

/*
	lcd_clrscr();
	//clr_i2c_rtc();
	read_rtcTD();
	lcd_gotoxy(0,0); lcd_puts("Sekunden  "); lcd_puts(trimm_string('0',itoa( _rtc_t[2],  s, 10), 4 ));
	lcd_gotoxy(0,1); lcd_puts("Minuten   "); lcd_puts(trimm_string('0',itoa( _rtc_t[1],  s, 10), 4 ));
	lcd_gotoxy(0,2); lcd_puts("Stunden   "); lcd_puts(trimm_string('0',itoa( _rtc_t[0],  s, 10), 4 ));

	lcd_gotoxy(0,3); lcd_puts("Tag       "); lcd_puts(trimm_string('0',itoa( _rtc_d[0],  s, 10), 4 ));
	lcd_gotoxy(0,4); lcd_puts("Monat     "); lcd_puts(trimm_string('0',itoa( _rtc_d[1],  s, 10), 4 ));
	lcd_gotoxy(0,5); lcd_puts("Jahr      "); lcd_puts(trimm_string('0',itoa( _rtc_d[2]+2000,  s, 10), 4 ));
	lcd_gotoxy(0,6); lcd_puts("Wochentag "); lcd_puts(trimm_string('0',itoa( _rtc_d[3],  s, 10), 4 ));

stop(2);
*/





	switch(__p)
	{	case 0:
			menu();
			break;
		case 1:
			m1();
			break;
		case 2:
			m2();
			break;
		case 3:
			m3();
			break;
		case 6:
			m6();
			break;
		case _CAM_SETTINGS:
			_Cam_Settings();
			break;
		case _POWERSTATUS:
			_PowerStatus();
			break;
		case _UHR:
		 	_Uhr(); 
			break;
		case _TIMERSETTING:
		 	_TimerSetting(); 
			break;
		case _CHAR_SET:
		 	_Char_Set(); 
			break;
		default:
			break;
	}


// ************************************ HAUPTSCHLEIFE ************************************
	for (;;)
	{	
		cli(); //Global Interrupt Disable
	   i_ = rc5_data;			// read two bytes from interrupt !
	   rc5_data = 0;
	   sei(); //Global Interrupt Enable

// --- Timer2 ---
		scan_dcf77();

		if(_ms10>=16 && ms10count==0)
			ms10count++;
		if(_ms10>=50 && ms10count==1)
			ms10count++;
		if(_ms10>=83 && ms10count==2)
			ms10count++;
		
		if(ms10count == 1 || ms10count == 2 || ms10count == 3)
		{
			if(ms10count == 3)
				ms10count=0;

			strcpy( UI_str,"BAT");
			ub=ReadChannel(UB);
			if(ub<1023)
				strcat( UI_str,insert_char( trimm_string('0',itoa( (ub * _scaler_BAT),  s, 10), 2 ), '.', 1)); 
			else
				strcat( UI_str, " >>  ");
			strcat( UI_str,"V");
			_ibat=ReadChannel(IBAT);
			if(_ibat>104) // 1mA
			{	strcat(UI_str,trimm_string(' ',itoa(_ibat * _m_IVCC + _b_IVCC,s,10),3 )); strcat(UI_str, "mA");
				mAh+= (_ibat * _m_IVCC + _b_IVCC);
			}
			else
			{ 	strcat( UI_str, "noBAT"); UI_str[0]='V'; UI_str[1]='c'; UI_str[2]='c'; }
			if(LCD_CONTROLLER_KS0073==2)
				strcat( UI_str, " ");	
				
			if(__p!=_HAUPTMENU && __p!=_POWERSTATUS && __p!=_UHR_STATUS)
			{	lcd_gotoxy(0,7); 
				lcd_puts( UI_str);
			}
		
		} // if(ms10count == 1 || ms10count == 2 || ms10count == 3)
// --- Timer2 ---
				


// --- Timer1 ---

		if (count__>=F_INTERRUPTS) //10000
		{	count__=0; sek10++; clock();
			if(blinki)
			{	gruenLED(20); blinki=0; 
			} //if(blinki) // set pin to low
			cpu_idle++;
			clock();
//			_hell_perc=(UBYTE)((UBYTE)((ReadChannel(LDR)*100L/1023)/5L)*5);
_hell_perc=(UBYTE)(((ReadChannel(LDR)*100L/1023L)/5L)*5L);
			if(fast_it>w3)
			{	if(!KoHe_flag && __p==_UHR /*&& ubat>5*/ )
				{lcd_gotoxy(12,3);lcd_putc(' ');lcd_puts(trimm_string(' ',itoa( mAh/3600, s,10),4));lcd_puts("mAh");}
				if(!KoHe_flag && __p==_UHR /* && !(ubat>5) */ )
				{lcd_gotoxy(12,3);	lcd_puts(" LDR"); lcd_puts(trimm_string(' ',itoa((UBYTE)(((ReadChannel(LDR)*100L/1023L)/5L)*5L),  s, 10),3));	lcd_putc('%');}

/*
					if((Ub * _scaler_BAT)<32)
					{	alarm1_clr_rtc();
						alarm_set=TRUE;
						woher=shutdown(SLEEP_MODE_PWR_DOWN);
						//	if(woher & 1<<KEY1)
						goto neustart;
					}						
*/

				if((__p==_UHR || __p==_UHR_STATUS)&& _test_i2c_rtc)
				{	
					strcpy( s, temperatur_str_rtc(-2)); // keine Batterie drin etwas Erwrmung bercksichtigen
					strcat( s, "C");
					lcd_gotoxy(14,1); 
					lcd_puts( s);
				}
				
				if(__p!=_POWERSTATUS)
				{
					if(!wait_hell_flag)
					{
						if( (_hell_perc < 40) && (hg_led_get() < 10) ) // wenn zu dunkel und kein HG_LED -> HG_LED auf minimum
							hg_led_set(10);
						if( (_hell_perc > 75) && (hg_led_get() > 0) ) // wenn sehr hell und HG_LED -> HG_LED aus
							hg_led_set(0);
					}
				}
								
				if(hg_led_get()==0)
					gruenLED(SET);
				else
					gruenLED(RESET);
				
				u_count++;
				if(u_count==6)
					u_count=0;
			
			} // if(fast_it>w3)
		} //if (count__>=F_INTERRUPTS)
		//} // if(softclock.seconds!=old_sec)

		res_key=get_key_press( ALL_KEYS );

		if(res_key)
	  		bedient=TRUE;

		if(__p==_KEY_TEST)
		{	//res_key=get_key_press( ALL_KEYS );
			//while( res_key )
			while( res_key || get_key_rpt( ALL_KEYS ) )
			{	
				lcd_gotoxy(1,1); ( res_key & (1<<KEY1)	) ? lcd_putc('1') : lcd_putc(' ');
				lcd_gotoxy(2,1); ( res_key & (1<<KEY2)	) ? lcd_putc('2') : lcd_putc(' ');
				lcd_gotoxy(3,1); ( res_key & (1<<KEY3)	) ? lcd_putc('3') : lcd_putc(' ');
				lcd_gotoxy(4,1); ( res_key & (1<<KEY4)	) ? lcd_putc('4') : lcd_putc(' ');
				lcd_gotoxy(5,1); ( res_key & (1<<KEY5)	) ? lcd_putc('5') : lcd_putc(' ');
				lcd_gotoxy(6,1); ( res_key & (1<<KEY6)	) ? lcd_putc('6') : lcd_putc(' ');
				//lcd_gotoxy(7,1); ( res_key & (1<<KEY7)	) ? lcd_putc('7') : lcd_putc(' ');
				//if(!res_key)
				//	lcd_puts("7");
//				res_key=get_key_press( ALL_KEYS );
				if(( (res_key & ((1<<KEY1)|(1<<KEY2)) ) == ((1<<KEY1) | (1<<KEY2)) ) ||
					( (res_key & ((1<<KEY2)|(1<<KEY3)) ) == ((1<<KEY2) | (1<<KEY3)) ) ||
					( (res_key & ((1<<KEY3)|(1<<KEY4)) ) == ((1<<KEY3) | (1<<KEY4)) ) ||
					( (res_key & ((1<<KEY4)|(1<<KEY5)) ) == ((1<<KEY4) | (1<<KEY5)) ) ||
					( (res_key & ((1<<KEY5)|(1<<KEY6)) ) == ((1<<KEY5) | (1<<KEY6)) ) ){ __p=_HAUPTMENU; break; }

				res_key=0;
			}
			if(!__p) { res_key=0; menu();	}
		} // if(__p==_KEY_TEST)

		fb();

		if(__p==99)
			goto neustart;

		if(_p_run==_ZUFALLSBILDER && (_ms10==0 || _ms10==10 || _ms10==20 || _ms10==30 || _ms10==40 || _ms10==50 || _ms10==60 || _ms10==70 || _ms10==80 || _ms10==90))
		{ _Zufallsbilder(); lcd_gotoxy(10,2); lcd_puts(p3_cnt); }

		if(__p!=_p_run)
			_p_run=_HAUPTMENU;		

		if(_bli)
			bli(_ASK);

		if(_p_run)
		{	switch(__p)
			{	case _BILDSERIE:
					_Bildserie();
					break;
				case _BEL_SERIE:
					_Bel_Serie();
					break;
				case _ZUFALLSBILDER:
					_Zufallsbilder();
					break;
			}
		} // if(_p_run)
		else
		{	if( __p==_BILDSERIE || __p==_BEL_SERIE || __p==_ZUFALLSBILDER || __p==_CAM_SETTINGS || __p==_UHRSTELLEN)
				if(res_key & (1<<KEY3) || res_key & (1<<KEY4))
				{	res_key=0;
					__tab();
				}
		} // else if(_p_run)

		if(res_key & ( 1<<KEY1 ))
		{	res_key=0;
			__p=_HAUPTMENU; _p_run=_HAUPTMENU;
			menu();
		}
		
		if(__p==_HAUPTMENU)
		{	
			if( !bedient && fast_it>(prog_beginn+1000) )
			{	__p=_UHR; alarm_beginn=fast_it+1000; cpu_idle=1; _p_run=0; count=0;	_Uhr();	
			} // if( !bedient && fast_it>(prog_beginn+1000) )
			
			if(bedient && res_key & ( 1<<KEY6 ))
			{	res_key=0;
				//eeprom_read_block(&s,&ee_mem[(line_+beginn_)*16],16);
				__p=atoi( menus[(line_+beginn_)]); // menus[(line_+beginn_)]
				switch(__p)
				{	case _BILDSERIE:
						m1();
						break;
					case _BEL_SERIE:
						m2();
						break;
					case _ZUFALLSBILDER:
						m3();
						break;
					case _AUSLOESUNG:
						//__p=_HAUPTMENU;
						//_p_run=_HAUPTMENU; 
						__p=_HAUPTMENU;
						ausloes(_CAM_CLEAR);
						ausloes(_CAM_DELAYx10MS);
						break;
					case _LICHT:
						__p=_HAUPTMENU;
						speedLED(TOGGLE);
						break;
					case _CAM_SETTINGS:
						m6();
						break;
					case _POWERSTATUS:
						m7();
						break;
					case _STATUS:
						_Status();
						break;
					case _UHR:
						_Uhr();
						break;
					case _TIMERSETTING:
						_TimerSetting();
						break;
					case _UHR_STATUS:
						_Uhr_Status();
						lcd_gotoxy(1,1);
						(_test_i2c_rtc)	?	lcd_putc('1')	:	lcd_putc('0');
						lcd_gotoxy(0,1);
						(_time_i2c_rtc && _test_i2c_rtc)	?	lcd_putc('1')	:	lcd_putc('0');
						break;
					case _CHAR_SET:
						_Char_Set();
						break;
					case _KEY_TEST:
						_Key_Test();
						break;
					case _UHRSTELLEN:
						_Uhrstellen();
						break;
					case _AUSSCHALTEN:
						alarm1_clr_rtc();
						//set_sleep_mode(SLEEP_MODE_PWR_SAVE);
						//alarm1_set_rel_rtc(40);
						//alarm_zeit=fast_it+500;
						alarm_set=TRUE;
						shutdown(SLEEP_MODE_PWR_DOWN);
						goto neustart;
						break;
					case _IRMP:
					 	_Irmp(); 
						break;
#ifdef BEEPER
					case _BEEP:
						__p=_HAUPTMENU;
						beep(20);
						break;
#endif					
					default:
						break;
				} // switch(__p)
			} // if(res_key & ( 1<<KEY6 ))
		} // if(__p==_HAUPTMENU)
		else // -> __p !=_HAUPTMENU)
		{	if(res_key & ( 1<<KEY6 ))
			{	res_key=0;
				if( __p>=_BILDSERIE && __p<_LICHT && _p_run!=__p )
				{	p_tab=__p*10+_tab;
					switch(p_tab)
					{	case 31:
							lcd_gotoxy(9,1);
							break;
						case 32: 
							lcd_gotoxy(19,1);
							break;
						case 33: 
							lcd_gotoxy(18,2);
							break;

						case 41:
							lcd_gotoxy(9,1);
							break;
						case 42: 
							lcd_gotoxy(19,1);
							break;
						case 43: 
							lcd_gotoxy(19,2);
							break;
						case 44: 
							lcd_gotoxy(18,0);
							break;

						case 51: 
							lcd_gotoxy(14,2);
							break;
					} // switch(p_tab)
					lcd_putc(' ');
					_p_run=__p;
				} // if( __p>=1 && __p<4 && _p_run!=__p )
				if(__p==_POWERSTATUS)
				{	p8_stat=!p8_stat;			
					_PowerStatus();
				}
/*
				if(__p==_UHR)
				{	if((DCF_LED_PORT & (1 << _dcfLED)) == 0)
						DCF_LED_PORT |= (1 << _dcfLED);
					else
						DCF_LED_PORT &=~(1 << _dcfLED);
				}
*/
				if(__p==_UHR_STATUS)
					d_flag=!d_flag;
				
				if(__p==_TIMERSETTING)
				{	switch(h_line_p10+h_beginn_p10)
					{	case 1:
							_bli_set=!_bli_set;
							lcd_gotoxy(11,h_line_p10); (_bli_set) ? lcd_puts(" AN") : lcd_puts("AUS");
							break;
						case 2:
							irPOWER(TOGGLE);
							lcd_gotoxy(11,h_line_p10); (IR_VCC_PORT & (1<<IR_VCC)) ? lcd_puts(" AN") : lcd_puts("AUS");
							break;
						case 3:
	   					if(DCF_VCC_PORT 	& (1 << _dcfVCC))   		// VCC_DCF an
   							DCF_VCC_PORT 	&= ~(1 << _dcfVCC);   	// VCC_DCF aus
	   					else
   							DCF_VCC_PORT 	|= (1 << _dcfVCC);   	// VCC_DCF an
							lcd_gotoxy(11,h_line_p10); (DCF_VCC_PORT & (1<<_dcfVCC)) ? lcd_puts(" AN") : lcd_puts("AUS");
					} // switch(h_line_p10+h_beginn_p10)
				} // if(__p==_TIMERSETTING)
			} // if(res_key & ( 1<<KEY6 ))
		} // else if(__p==_HAUPTMENU)

		if(__p==_HAUPTMENU || __p==_TIMERSETTING)
		{	while( (res_key & ( 1<<KEY2 )) || get_key_rpt( 1<<KEY2 ))
			{	scr_up();
				res_key=0;
			}
			while( (res_key & ( 1<<KEY5 )) || get_key_rpt( 1<<KEY5 ))
			{	scr_down();
				res_key=0;
			}
		} // if(__p==_HAUPTMENU || __p==_BILDSERIE)

		if(__p==_CHAR_SET)
		{	while( (res_key & ( 1<<KEY2 )) || get_key_rpt( 1<<KEY2 ))
			{	if(__i<255) 
					__i++;
				#if !LCD_CONTROLLER_KS0073
					switch(__i)
					{	case 8:
							__i=0x20;
							break;
						case 0x80:
							__i=0xa0;
							break;
						default:
							break;
					} // switch(__i)
				#endif
				res_key=0;
			} // while( (res_key & ( 1<<KEY4 )) || get_key_rpt( 1<<KEY4 ))
			
			while( (res_key & ( 1<<KEY5 )) || get_key_rpt( 1<<KEY5 ))
			{	if(__i>0) 
					__i--;
				#if !LCD_CONTROLLER_KS0073
					switch(__i)
					{	
						case 0x9f:
							__i=0x7f;
							break;
						case 0x1f:
							__i=7;
							break;
						default:
							break;
					} // switch(__i)
				#endif
				res_key=0;
			} // while( (res_key & ( 1<<KEY3 )) || get_key_rpt( 1<<KEY3 ))
			lcd_gotoxy(0,1); 
			lcd_puts(trimm_string(' ',itoa(__i,  s, 10),3)); lcd_putc(' '); 
			lcd_puts(trimm_string('0',itoa(__i,  s, 16),2)); lcd_putc(' ');
			lcd_putc(__i);
		} // if(__p==_CHAR_SET)

		if(_ms10>=16 && check_ms==3 ) {	check_ms=1; not_checked=TRUE; }
		if(_ms10>=50 && check_ms==1 ) {	check_ms=2; not_checked=TRUE; }
		if(_ms10>=83 && check_ms==2 ) {	check_ms=3; not_checked=TRUE; }

		if(not_checked)
		{	
		
			not_checked=FALSE;
/*			
			check_dcf(); // WICHTIG vor time update !!!!
			softclock._time_[0]=0;
			strcpy(softclock._time_, trimm_string('0',itoa(softclock.hours,  s, 10),2));
			strcat(softclock._time_, ":");
			strcat(softclock._time_, trimm_string('0',itoa(softclock.minutes,  s, 10),2));
			strcat(softclock._time_, ":");
			strcat(softclock._time_, trimm_string('0',itoa(softclock.seconds,  s, 10),2));
						
			if(softdate.jjjj && !strlen( (char *)softdate._date_) && softdate.tt && softdate.mo)
			{	strcpy( (char *)softdate._wochentag_, strWochentagname( dcf.wkday ));
				strcat( (char *)softdate._wochentag_, trimm_string(' ', "          ", 10-strlen( (char *)softdate._wochentag_)));
				softdate._date_[0]=0;
				strcat( (char *)softdate._date_, trimm_string('0',itoa(softdate.tt,  s, 10),2));
				strcat( (char *)softdate._date_, ".");
				strcat( (char *)softdate._date_, trimm_string('0',itoa(softdate.mo,  s, 10),2));
				strcat( (char *)softdate._date_, ".");
				strcat( (char *)softdate._date_, trimm_string('0',itoa(softdate.jjjj,  s, 10),4));
			} // if(softdate.jjjj && !strlen(softdate._date_))
			else
				softdate._date_[0]=0;
			if( setze && (_500ms>0) )
			{	if(!gesetzt) {lcd_gotoxy(19,0);lcd_putc(5);gesetzt=TRUE;} // if(!gesetzt) 
			}
			if( gesetzt && (_500ms>50) ) 
			{	lcd_gotoxy(19,0);lcd_putc(4); _500ms=0;gesetzt=FALSE;setze=FALSE; }
*/

			if(__p==_UHR_STATUS)
			{  // lcd_gotoxy(7,0); lcd_puts(dcf.err);
				//DCF_LED_PORT |= (1 << _dcfLED);
/*
				lcd_gotoxy(15,2); lcd_puts(trimm_string(' ',itoa(merke_dcf_msec_0*10,  s, 10),3)); lcd_puts("ms");
				lcd_gotoxy(15,3); lcd_puts(trimm_string(' ',itoa(merke_dcf_msec_1*10,  s, 10),3)); lcd_puts("ms");
*/				
				lcd_gotoxy(0,3); lcd_puts("("); lcd_puts(trimm_string(' ',itoa(new_stat_grenze*10,  s, 10),3)); 
				lcd_puts(")");

				lcd_gotoxy(5,1);
				if(_test_i2c_rtc)
				{	if(!d_flag)
						lcd_puts(time_str_rtc());
					else
						lcd_puts(date_str_rtc(_SHORT));
				}
				else
					lcd_puts("........"); 
				// per memset machen

				lcd_gotoxy(0,1); (_time_i2c_rtc)	?	lcd_puts("1")	:	lcd_puts("0");
/*
				lcd_gotoxy(0,2); (dcf.okay==1)	? 	lcd_puts("1")	:	lcd_puts("0");
								 (dcf.bitcnt>0)	? 	lcd_puts("1")	:	lcd_puts("0");
				lcd_gotoxy(5,2); 

				if(!d_flag)
				{	lcd_puts(trimm_string('0',itoa(dcf.hour,  s, 10),2)); lcd_putc(':');
					lcd_puts(trimm_string('0',itoa(dcf.min,  s, 10),2));  lcd_putc(':');
					lcd_puts(trimm_string('0',itoa(dcf.bitcnt,  s, 10),2));
				}
				else
				{	lcd_puts(trimm_string('0',itoa(dcf.day,  s, 10),2)); lcd_putc('.');
					lcd_puts(trimm_string('0',itoa(dcf.month,  s, 10),2));  lcd_putc('.');
					lcd_puts(trimm_string('0',itoa(dcf.year,  s, 10),2));
				}
				
				lcd_gotoxy(17,0); lcd_puts(trimm_string('0',itoa(dcf.bitcnt,  s, 10),2));
				if(!d_flag)
				{	lcd_gotoxy(5,3); lcd_puts(softclock._time_);
				}
				else
				{	lcd_gotoxy(5,3); 
					lcd_puts("........");
					lcd_gotoxy(5,3); 				
					lcd_puts(lefts( (char *)softdate._date_,6)); lcd_puts(rights( (char *)softdate._date_,2));
				}

*/
			} // if(__p==_TIMERSETTING)
			else 
			{	if(__p!=_HAUPTMENU)
				{	if(__p!=_UHR)
						;
/*
						if((DCF_LED_PORT & (1 << _dcfLED)) != 0)
							DCF_LED_PORT &=~ (1 << _dcfLED);
*/
				}
			}

			if(__p!=_HAUPTMENU && __p!=_POWERSTATUS && __p!=_UHR_STATUS)
			{	lcd_gotoxy(0,3); 
				lcd_puts( UI_str);
			}

			if(__p==_POWERSTATUS)
			{	
				if(!p8_stat)
				{	lcd_gotoxy(14,0);lcd_putc('B');
					lcd_gotoxy(4,1); 	lcd_puts(trimm_string(' ',itoa(ReadChannel(UB),  s, 10),4)); lcd_puts("  ");
					lcd_gotoxy(14,1); 	lcd_puts(trimm_string(' ',itoa(ReadChannel(IBAT),  s, 10),4)); lcd_puts("  ");
/*
					lcd_gotoxy(4,2); 	lcd_puts(trimm_string(' ',itoa(ReadChannel(VCC),  s, 10),4)); lcd_puts("  ");
					lcd_gotoxy(14,2); 	lcd_puts(trimm_string(' ',itoa(ReadChannel(IVCC),  s, 10),4)); lcd_puts("  ");
*/
					lcd_gotoxy(4,3); 	lcd_puts(trimm_string(' ',itoa(ReadChannel(LDR),  s, 10),4)); lcd_putc(' ');
				}
				else
				{	lcd_gotoxy(14,0);	lcd_putc('D');
					lcd_gotoxy(3,1); 	lcd_puts(insert_char( trimm_string('0',itoa((ReadChannel(UB) * _scaler_BAT *10),  s, 10), 3 ), ',', 1));
					lcd_putc('V');
					lcd_gotoxy(8,1); 	lcd_puts(trimm_string(' ',itoa(((ReadChannel(IBAT)  * _m_IVCC - _b_IVCC) ),  s, 10), 3 ));		lcd_puts("mA");
					lcd_gotoxy(13,1);	lcd_puts(trimm_string(' ',itoa( mAh/3600 ,  s, 10), 4 ));			lcd_puts("mAh");
/*
					lcd_gotoxy(3,2); 	lcd_puts(insert_char( trimm_string(' ',itoa((ReadChannel(VCC) * _scaler_VCC *10),  s, 10), 3 ), ',', 1));
					lcd_putc('V');
					lcd_gotoxy(8,2); 	lcd_puts(trimm_string(' ',itoa((ReadChannel(IVCC) * _m_IVCC - _b_IVCC),  s, 10), 3 ));	
					lcd_puts("mA");	lcd_gotoxy(18,2); lcd_putc(' ');	lcd_putc(0);
*/
					_hell_perc=(UBYTE)(((ReadChannel(LDR)*100L/1023L)/5L)*5L);
					lcd_gotoxy(10,1); lcd_puts("LDR : "); lcd_puts(trimm_string(' ', itoa(_hell_perc,s,10), 3)); lcd_puts("%");
					lcd_gotoxy(4,3); 	lcd_puts(trimm_string(' ',itoa((UBYTE)(((ReadChannel(LDR)*100L/1023L)/5L)*5L),  s, 10),3));	lcd_putc('%');
				}
			}
			
			if(__p==_STATUS)
			{  
			/*
				lcd_gotoxy(12,2); lcd_puts("dcfcnt"); lcd_puts(trimm_string('0',itoa(dcf.bitcnt,  s, 10),2));	
				lcd_gotoxy(18,1); lcd_puts(trimm_string('0',itoa(dcf.min,  s, 10),2));	
				lcd_gotoxy(18,0); 
				lcd_putc(softclock.dcf_set);
			*/
				lcd_gotoxy(4,2);  lcd_puts(trimm_all( (100*kon/_KON_PEEK), hg_led_get(), 3 ) ); 	
			}

			if(__p==_IRMP)
			{	if (irmp_get_data(&irmp_data))
			   {
					sek10=0;
/*
					if(!strcmp((char *)Proto[irmp_data.protocol-1],"KASEIKYO"))
						gelb_blink1s();
					else
*/
					gruenLED(100);

					lcd_gotoxy(0,1); lcd_puts("R: Code:            ");
					lcd_gotoxy(9,1); lcd_puts((char *)Proto[irmp_data.protocol-1]);
					lcd_gotoxy(0,2); lcd_puts("A:       C:         ");
					lcd_gotoxy(3,2); lcd_puts(itoa(irmp_data.address,s,10)); 
					lcd_gotoxy(12,2); lcd_puts(itoa(irmp_data.command,s,10)); 
					//lcd_gotoxy(0,3); lcd_puts("                    ");
  		
					if(!strcmp((char *)Proto[irmp_data.protocol-1], "RC5(x)"))
					{	lcd_gotoxy(5,2); 
						lcd_puts("("); lcd_puts(itoa(irmp_data.address,s,10)); lcd_puts(")");
					}
		
					/*
					lcd_gotoxy(14,1);	
					lcd_puts(itoa(irmp_data.command,s,16)); 
*/
					if(!strcmp((char *)Proto[irmp_data.protocol-1], "RC5(x)"))
					{	lcd_gotoxy(15,2);	
						lcd_puts("("); lcd_puts(itoa(((irmp_data.address*100)+irmp_data.command),s,10)); lcd_puts(")"); }
        
					// ir signal decoded, do something here...
			        // irmp_data.protocol is the protocol, see irmp.h
			        // irmp_data.address is the address/manufacturer code of ir sender
			        // irmp_data.command is the command code

					/*
					strcpy(temp2,"# Code: "); strcat(temp2,(char *)Proto[irmp_data.protocol-1]);
					strcat(temp2,", A: ");	strcat(temp2,itoa(irmp_data.address,s,16)); 
					strcat(temp2,", C: ");	strcat(temp2,itoa(irmp_data.command,s,16)); 
					strcat(temp2,"\r\n");
					
					#if IRMP_LOGGING != 0       // 1: log IR signal (scan), 0: do not (default)
						if(strlen(temp2_bak)==0)
						uart_puts(temp2);
					#endif

					#if IRMP_LOGGING != 0       // 1: log IR signal (scan), 0: do not (default)
						if (strcmp(temp2, temp2_bak)!=0)
						{	strcpy(temp2_bak, temp2);
							uart_puts(temp2);
						}
					#endif
					*/

				}

				if (sek10==15)
				{	lcd_gotoxy(0,1); lcd_puts("R: Code:            ");
					lcd_gotoxy(0,2); lcd_puts("A:       C:         ");
					sek10=0;
				}
			}

			if(__p==_UHR)
			{	if(DCF_LED_PORT & (1 << _dcfLED))
				{	lcd_gotoxy(6,0); lcd_puts("AN"); }
				else
				{	lcd_gotoxy(6,0); lcd_puts("  "); }
				
				lcd_gotoxy(0,1); 			
				if(_test_i2c_rtc && strlen(time_str_rtc()))
					lcd_puts(time_str_rtc());
				else
					lcd_puts( softclock._time_);
					
				lcd_gotoxy(0,2); 
				if(_test_i2c_rtc && _rtc_d[2]>=7)
				{	lcd_puts(wt_str_rtc());
					lcd_gotoxy(10,2); lcd_puts(date_str_rtc(_NORMAL));
				}
				else
				{	if(strlen( (char *)softdate._wochentag_)) lcd_puts( (char *)softdate._wochentag_);
					lcd_gotoxy(10,2); 
					if(strlen( (char *)softdate._date_)) lcd_puts( (char *)softdate._date_);
				}
/*				
				if((softclock.dcf_set==' ') && !dcftimeout && !_true_rtc)
				{ lcd_gotoxy(13,0); lcd_puts("dcf "); lcd_puts(trimm_string('0',itoa(dcf.bitcnt,  s, 10),2)); }
*/
				if(res_p9)
				{	_Uhr();
					lcd_gotoxy(18,0); 
/*
					lcd_putc(softclock.dcf_set);
					DCF_LED_PORT &=~(1 << _dcfLED);
*/
				}
/*
				if(fast_it>dcf_timeout && !dcftimeout)
				{	dcftimeout=TRUE;
					lcd_gotoxy(13,0); lcd_puts("      ");
				}
				
				if( !bedient && fast_it>alarm_beginn && (_true_rtc || softclock.dcf_set == 1) )
				{	
	   			if(!alarm_set)
					{
						alarm1_clr_rtc();
						set_sleep_mode(SLEEP_MODE_PWR_SAVE);
						alarm1_set_rel_rtc(40);
						alarm_zeit=fast_it+500;
						alarm_set=TRUE;
					}

	   			if(cpu_idle && fast_it>alarm_zeit && alarm_set) 
					{	
						//woher=shutdown(SLEEP_MODE_PWR_DOWN);
						if((ReadChannel(LDR)/10.23)>1 && ubat>5)
							hg_led_set(0);
						woher=shutdown(SLEEP_MODE_IDLE);
							hg_led_set(hg_led_get());

						alarm_set=FALSE;
						alarm_beginn=fast_it+500;
						//if(__p==_UHR) {	lcd_gotoxy(6,0); lcd_puts(trimm_string('0',itoa(woher,  s, 16),2)); stop(1);} woher 1-80 hex ! KEY1,2,4,8,0x10,0x20->Al1=0x40,Al2=0x80
					}
				} // if( !bedient && fast_it>(alarm_beginn+1000) )
*/
				lcd_gotoxy(6,0);lcd_puts((char *)_uhr_string);
				/* stop(1); */
			} // if(__p==_UHR)

			if(__p==_UHRSTELLEN)
			{	
				lcd_gotoxy(0,1); lcd_puts( wt_str_rtc()); lcd_gotoxy(10,1); lcd_puts(date_str_rtc(_NORMAL));
			}
/*			
			if(new_stat_grenze==0)
			{	if(merke_dcf_msec_0>0 && merke_dcf_msec_1>0)
					new_stat_grenze=(merke_dcf_msec_0+merke_dcf_msec_1)/2;
			}
			else
			{	new_stat_grenze+=((merke_dcf_msec_0+merke_dcf_msec_1)/2);
				new_stat_grenze/=2;
				
				if(new_stat_grenze>10 && new_stat_grenze<15)
					_stat.sec_grenze=new_stat_grenze;
			}
*/
			if( __p!=_HAUPTMENU /* && __p!=_POWERSTATUS */ && __p!=_UHR && __p!=_UHR_STATUS && !(KoHe_flag && (__p!=_STATUS)) )
			{ if(!(KoHe_flag && __p==_ZUFALLSBILDER)) { lcd_gotoxy(12,3); lcd_puts(time_str_rtc()); } }

			// if(_ms10==16 || _ms10==50 || _ms10==83)
		} 	// if(not_checked)

		if(!_p_run)
		{	p_tab=__p*10+_tab;
			switch(p_tab)
			{	case 31:
					lcd_gotoxy(6,1); lcd_puts(trimm_string(' ',itoa(__vo1,  s, 10),3));lcd_putc('_');
					break;
				case 32: 
					lcd_gotoxy(17,1);  lcd_puts(trimm_string(' ',itoa(__bi1,  s, 10),2));lcd_putc('_');
					break;
				case 33: 
					lcd_gotoxy(16,2); lcd_puts(trimm_string(' ',itoa(__zw1,  s, 10),2));lcd_putc('_');
					break;
		
				case 41:
					lcd_gotoxy(6,1); lcd_puts(trimm_string(' ',itoa(__vo2,  s, 10),3));lcd_putc('_');
					break;
				case 42: 
					lcd_gotoxy(17,1);  lcd_puts(trimm_string(' ',itoa(__bi2,  s, 10),2));lcd_putc('_');
hilf_=__zw2;
hilf_<<=(__bi2*2);
if( hilf_< (ULONG)100)
{ 	lcd_gotoxy(0,2); strcpy(s,"1/"); 
	strcat(s,utoa(100/(__zw2 << (__bi2*2)),  s2, 10));
	strcat(s,"s Z");lcd_puts(trimm_string(' ',s,8));
}
else
{	if( hilf_< (ULONG)65000)
	{ lcd_gotoxy(0,2); lcd_puts(trimm_string(' ',utoa((__zw2 << (__bi2*2))/100,  s, 10),4));lcd_puts("s  Z");}
	else
	{ lcd_gotoxy(0,2); lcd_puts(">650s  Z");}
}
					break;
				case 43: 
					lcd_gotoxy(14,2); 
					if(__zw2>=100) 
					{	lcd_puts(trimm_string(' ',itoa(__zw2/100, s, 10),5)); }
					else
					{ 	strcpy(s,"1/"); strcat(s,itoa(100/__zw2, s2, 10)); lcd_puts(trimm_string(' ',s,5));}
					lcd_putc('_'); 
hilf_=__zw2;
hilf_<<=(__bi2*2);
if( hilf_< (ULONG)100)
{ 	lcd_gotoxy(0,2); strcpy(s,"1/"); 
	strcat(s,utoa(100/(__zw2 << (__bi2*2)),  s2, 10));
	strcat(s,"s Z");lcd_puts(trimm_string(' ',s,8));
}
else
{	if( hilf_< (ULONG)65000)
	{ lcd_gotoxy(0,2); lcd_puts(trimm_string(' ',utoa((__zw2 << (__bi2*2))/100,  s, 10),4));lcd_puts("s  Z");}
	else
	{ lcd_gotoxy(0,2); lcd_puts(">650s  Z");}
}
					break;
				case 44: 
					lcd_gotoxy(17,0); (__sva) ? lcd_putc('1') : lcd_putc('0'); lcd_putc('_');
					break;
				case 51:
					lcd_gotoxy(11,2); lcd_puts(trimm_string(' ',itoa(__we,  s, 10),3));lcd_putc('_');
					break;

				case 61:
					lcd_gotoxy(4,1); 
					(__sva==1) ? lcd_puts(" AN") : lcd_puts("AUS");	
					lcd_putc('_');
					break;
				case 62: 
					lcd_gotoxy(16,1);
					switch(_rausch)
					{	case 0:
							lcd_puts("AUS_");
							break;
						case 1:
							lcd_puts("AN1_");
							break;
						case 2:
							lcd_puts("AN2_");
							break;
					}
					break;
				case 63: 
					lcd_gotoxy(13,2); 
					switch(_autopower)
					{	case 0:
							lcd_puts("AUS_   ");
							break;
						case 1:
						case 2:
						case 4:
						case 8:
							lcd_puts(trimm_string(' ',itoa(_autopower,  s, 10),3));lcd_putc('_');lcd_puts("min");
							break;
						case 15:
							lcd_puts(" 15_min");
							break;
						case 30:
							lcd_puts(" 30_min");
							break;
					}
					break;

				case 151: 
					lcd_gotoxy(12,2);lcd_putc(7);lcd_putc(7);
					break;
				case 152: 
					lcd_gotoxy(15,2);lcd_putc(7);lcd_putc(7);
					break;
				case 153: 
					lcd_gotoxy(10,2);lcd_putc(6);lcd_putc(6);
					break;
				case 154: 
					lcd_gotoxy(13,2);lcd_putc(6);lcd_putc(6);
					break;
				case 155: 
					lcd_gotoxy(16,2);lcd_putc(6);lcd_putc(6);lcd_putc(6);lcd_putc(6);
					break;

			} // switch(p_tab)
		} // if(!_p_run)
		
		if(__p!=_HAUPTMENU)
		{	if( __p!=_BILDSERIE && __p!=_BEL_SERIE && __p!=_ZUFALLSBILDER && __p!=_CAM_SETTINGS && __p!=_TIMERSETTING && __p!=_CHAR_SET && __p!=_KEY_TEST  && __p!=_UHRSTELLEN )
			{	while( (res_key & ( 1<<KEY2 )) || get_key_rpt( 1<<KEY2 ))
					hg_led_plus();
				while( (res_key & ( 1<<KEY5 )) || get_key_rpt( 1<<KEY5 ))
					hg_led_minus();
				while( (res_key & ( 1<<KEY3 )) || get_key_rpt( 1<<KEY3 ))
					kon_plus();
				while( (res_key & ( 1<<KEY4 )) || get_key_rpt( 1<<KEY4 ))
					kon_minus();
			} // if( __p!=_BILDSERIE && __p!=_BEL_SERIE && __p!=_ZUFALLSBILDER && __p!=_CAM_SETTINGS && __p!=_TIMERSETTING && __p!=_CHAR_SET && __p!=_KEY_TEST  && __p!=_UHRSTELLEN )

			if( __p==_BILDSERIE || __p==_BEL_SERIE || __p==_ZUFALLSBILDER || __p==_CAM_SETTINGS || __p==_UHRSTELLEN )
			{	while( (res_key & ( 1<<KEY2 )) || get_key_rpt( 1<<KEY2 ))
				{	p_tab=__p*10+_tab;
					switch(p_tab)
					{	case 31: //VO 
							if(__vo1<255)
								__vo1++;
							break;
						case 43: //VO 
							if(__zw2>=100 && __zw2<65000)
							{	if(__zw2%100!=0)
									__zw2=(UWORD)(__zw2/100)*100;	
								//__zw2+=100;
								__zw2<<=1;
								if(__zw2==1600)
									__zw2=1500;
							}
							else
								__zw2<<=1;
							
							if(__zw2>50 && __zw2<150)
								__zw2=100;
							break;
						case 32: //BI
							if(__bi1<99)
								__bi1++;
							break;
						case 42: //BI
							if(__bi2<99)
								__bi2++;
							break;
						case 33: //ZW 
							if(__zw1<99)
								__zw1++;
							break;
						case 41: //ZW
							if(__vo2<99)
								__vo2++;
							break;
						case 44: //SVA 
							if(!__sva)
								__sva=TRUE;
							break;

						case 71: //SVA 
							if(!__sva)
								__sva=TRUE;
							break;
						case 72: 
							if(_rausch<2)
								_rausch++;
							break;
						case 73: 
							if(_autopower<30)
								_autopower*=2;
							if(_autopower==16)
								_autopower=15;
							if(_autopower==0)
								_autopower=1;
							break;

						case 112: 
						case 113: 
							scr_up();							
							break;
						
						case 151: 
							if(__hour<23)
								__hour++;
							else
								__hour=0;
							write_rtc( 2, int2bcd(__hour) );
							break;
						case 152: 
							if(__minute<59)
								__minute++;
							else
								__minute=0;
							write_rtc( 1, int2bcd(__minute) );
							break;
						case 153: 
							if(__day<Monatstage( __year, __month ))
								__day++;
							else
								__day=1;
							write_rtc( 4, int2bcd(__day) );
							write_rtc( 3, wochentag_im_jahr(__year, tagesnummer( __year, __month, __day )));
							break;
						case 154: 
							if(__month<12)
								__month++;
							else
								__month=1;
							write_rtc( 5, int2bcd(__month) );
							write_rtc( 3, wochentag_im_jahr(__year, tagesnummer( __year, __month, __day )));
							break;
						case 155: 
							if(__year<2099)
								__year++;
							else
								__year=2008;
							write_rtc( 6, int2bcd(__year-2000) );
							write_rtc( 3, wochentag_im_jahr(__year, tagesnummer( __year, __month, __day )));
							break;

					} // switch(p_tab)
					res_key=get_key_press( (1<<KEY2) );
				} // while( (res_key & ( 1<<KEY3 )) == ( 1<<KEY3 ) || get_key_rpt( 1<<KEY3 ))

				while( (res_key & ( 1<<KEY5 )) || get_key_rpt( 1<<KEY5 ))
				{	p_tab=__p*10+_tab;
				 	switch(p_tab)
					{	case 31: //VO
							if(__vo1>0)
								__vo1--;
							break;
						case 43: //VO
							if(__zw2==2)
								__zw2=1;
							if(__zw2>200)
								__zw2>>=1;
							if(__zw2==700)
								__zw2=800;
	
								//__zw2-=100;
							else
								if(__zw2>2)
									__zw2>>=1;
							break;
						case 32: //BI 
							if(__bi1>1)
								__bi1--;
							break;
						case 42: //BI
							if(__bi2>1)
								__bi2--;
							break;
						case 33: //ZW 
							if(__zw1>=1)
								__zw1--;
							break;
						case 41: //ZW 
							if(__vo2>=1)
								__vo2--;
							break;
						case 44: //ZW 
							if(__sva)
								__sva=FALSE;
							break;

						case 71: //SVA 
							if(__sva)
								__sva=FALSE;
							break;
						case 72: 
							if(_rausch>0)
								_rausch--;
							break;
						case 73: 
							if(_autopower>0)
								_autopower/=2;
							if(_autopower==7)
								_autopower=8;
							break;

						case 111: 
						case 112: 
							scr_down();							
							break;

						case 151: 
							if(__hour>=1)
								__hour--;
							write_rtc( 2, int2bcd(__hour) );
							break;
						case 152: 
							if(__minute>=1)
								__minute--;
							write_rtc( 1, int2bcd(__minute) );
							break;
						case 153: 
							if(__day>1)
								__day--;
							write_rtc( 4, int2bcd(__day) );
							write_rtc( 3, wochentag_im_jahr(__year, tagesnummer( __year, __month, __day )));
							break;
						case 154: 
							if(__month>1)
								__month--;
							write_rtc( 5, int2bcd(__month) );
							write_rtc( 3, wochentag_im_jahr(__year, tagesnummer( __year, __month, __day )));
							break;
						case 155: 
							if(__year>2008)
								__year--;
							write_rtc( 6, int2bcd(__year-2000) );
							write_rtc( 3, wochentag_im_jahr(__year, tagesnummer( __year, __month, __day )));
							break;
					} // switch(p_tab)
					res_key=get_key_press( (1<<KEY5) );
				} // while( (res_key & ( 1<<KEY4 )) == ( 1<<KEY4 ) || get_key_rpt( 1<<KEY4 ))
			} // if( __p==_BILDSERIE || __p==_BEL_SERIE || __p==_ZUFALLSBILDER )
		} // if(__p!=_HAUPTMENU)

		if(KoHe_flag)
		{
		 	if(fast_it>_hk_sec)
			{	lcd_gotoxy(12,3); lcd_puts("        "); KoHe_flag=FALSE, last_kohe=' '; }
			else
			{	if(last_kohe=='H')
					{ lcd_gotoxy(12,3);  lcd_puts("    H"); lcd_puts( trimm_string('0', itoa(hg_led_get(), s, 10), 3)); }
				if(last_kohe=='K')
					{ lcd_gotoxy(12,3);  lcd_puts("    K"); lcd_puts( trimm_string('0', itoa((100*kon/_KON_PEEK), s, 10), 3));  }
			}
		}

		if(!bedient)
		{
			if(off==0)
			{
				if((UBYTE)(((ReadChannel(LDR)*100L/1023L)/5L)*5L)<10 /*&& (ubat>5)*/)
					off=BATT_OFF;
				else
					off=NORMAL_OFF;
			}
/*
			if(cpu_idle>=off)
			{
				alarm1_clr_rtc();
				woher=shutdown(SLEEP_MODE_PWR_DOWN);
				goto neustart;
			}
			if(__p==_UHR && cpu_idle>30)
			{ lcd_gotoxy(7,0);  lcd_puts(" aus "); lcd_puts( trimm_string(' ', itoa((off-cpu_idle), s, 10), 4)); lcd_puts("s");}
*/
		}

#ifdef BEEPER
		if(__p==_BEEP)
			__p=_HAUPTMENU;
#endif
/*
	//OCR1BL = 230;	// kon
	OCR1AL = 255;	// hell
*/

		if (sek10>=5)
		{	
			sek10=0;
			irPOWER(1); // zur Sicherheit, solange kein KEY: RESET IR off
		} // if (sek10==15)

		flags_abarbeiten();
		
		if(!wait_hell_flag)
		{
			if( (_hell_perc < 40) && (hg_led_get() < 10) ) // wenn zu dunkel und kein HG_LED -> HG_LED auf minimum
				hg_led_set(10);
			if( (_hell_perc > 75) && (hg_led_get() > 0) ) // wenn sehr hell und HG_LED -> HG_LED aus
				hg_led_set(0);
		}
		res_key=0;

	} // for (;;)
}


